//*****************************************************************************
// File Name            : helloworld_i2c_lcd.c
//-----------------------------------------------------------------------------
// Function             : helloworld_i2c_lcd
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2016/01/25
//*****************************************************************************
#include <stdio.h>
#include "platform.h"
#include "xparameters.h"
#include "xgpio.h"
#include "xiic.h"
#include "xil_io.h"

#define IIC_BASE_ADDRESS    XPAR_IIC_0_BASEADDR
#define IIC_LCD_SADR 0x3e
#define IIC_LCD_WR_CMD_END  0x00
#define IIC_LCD_WR_DAT_END  0x40

    #define IIC_ADT7410_SADR 0x48

void print(char *str);

void iic_lcd_cmd_wr(u8 cmd){
u8 WriteBuffer[2];
WriteBuffer[0]=IIC_LCD_WR_CMD_END;
WriteBuffer[1]=cmd;
XIic_Send(IIC_BASE_ADDRESS,IIC_LCD_SADR,WriteBuffer,2,0);
}

void iic_lcd_dat_wr(char dat){
u8 WriteBuffer[2];
WriteBuffer[0]=IIC_LCD_WR_DAT_END;
WriteBuffer[1]=(u8)dat;
XIic_Send(IIC_BASE_ADDRESS,IIC_LCD_SADR,WriteBuffer,2,0);
}

void iic_lcd_print(char *s)
{
    while(*s) iic_lcd_dat_wr(*s++);
}


int iic_adt4710_rd(){
u8 WriteBuffer[3];
int temp;
XIic_Recv(IIC_BASE_ADDRESS,IIC_ADT7410_SADR,WriteBuffer,2,0);
temp = WriteBuffer[0]*256 +  WriteBuffer[1];
return temp;
}

int main()
{
    int i,lp,flg;
    int temp,temp_s;
    init_platform();

    print("Hello World i2c\n\r");

    XGpio xgpout;
    XGpio_Config xcfg_out;
    xcfg_out.DeviceId = XPAR_AXI_GPIO_0_DEVICE_ID;
    XGpio_CfgInitialize(&xgpout, &xcfg_out, XPAR_AXI_GPIO_0_BASEADDR);
    iic_lcd_cmd_wr(0x38);
    iic_lcd_cmd_wr(0x39);
    iic_lcd_cmd_wr(0x14);
    iic_lcd_cmd_wr(0x70);
    iic_lcd_cmd_wr(0x56);
    iic_lcd_cmd_wr(0x6c);
    i=0xff;
    for(lp=0;lp<100000;lp++)
      XGpio_DiscreteWrite(&xgpout,1,i);
    iic_lcd_cmd_wr(0x38);
    iic_lcd_cmd_wr(0x0c);
    iic_lcd_cmd_wr(0x01);
    while(1){
      for(i=0x0;i<0x40;i++){
        for(lp=0;lp<5000;lp++)
          XGpio_DiscreteWrite(&xgpout,1,i);      
      }
      iic_lcd_print("Hello ");
      iic_lcd_dat_wr(0x60);
      if (flg==0){
        iic_lcd_print("(^^)/");
        flg=1;
      }
      else{
        iic_lcd_print("(^^)-");
        flg=0;
       }
      iic_lcd_cmd_wr(0xc0); //next line
      iic_lcd_print("ZYBO");
      iic_lcd_cmd_wr(0x80); //return home
      //adt7410

      temp =  iic_adt4710_rd();
      temp_s = (0x7f & temp)/1.28;
      temp = temp >> 7;
      xil_printf("%2d.%2d\n",temp,temp_s);


    }

    cleanup_platform();
    return 0;
}
