//*****************************************************************************
// File Name            : test_mb.v
//-----------------------------------------------------------------------------
// Function             : test_bench
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2016/01/25
//*****************************************************************************
`timescale 1ns / 1ps
module test_mb;
  parameter clk_period = 10;
  parameter clk_period_hf  = clk_period/2;
  reg clock_rtl;
  reg [7:0]gpio_rtl_0_tri_i;
  wire [7:0]gpio_rtl_tri_o;
  tri1 iic_rtl_scl_io;
  tri1 iic_rtl_sda_io;
  reg reset_rtl;
  reg reset_rtl_0;
  reg uart_rtl_rxd;
  wire uart_rtl_txd;
  
   mb_wrapper  mb_wrapper
         (.clock_rtl(clock_rtl),
          .gpio_rtl_0_tri_i(gpio_rtl_0_tri_i),
          .gpio_rtl_tri_o(gpio_rtl_tri_o),
          .iic_rtl_scl_io(iic_rtl_scl_io),
          .iic_rtl_sda_io(iic_rtl_sda_io),
          .reset_rtl(reset_rtl),
          .reset_rtl_0(reset_rtl_0),
          .uart_rtl_rxd(uart_rtl_rxd),
          .uart_rtl_txd(uart_rtl_txd)
          );
          
  initial begin
    repeat(100000) begin
      clock_rtl<=1'b0;
      #clk_period_hf;
      clock_rtl<=1'b1;
      #clk_period_hf;
    end
  end
  
  initial begin
    reset_rtl =1'b1;
    reset_rtl_0 =1'b1;
    uart_rtl_rxd = 1'b1;
    gpio_rtl_0_tri_i = 8'h00;
    #(clk_period*10);
    reset_rtl =1'b0;
    reset_rtl_0 =1'b0;
    #(clk_period*100000);
    $stop;
  end
  
endmodule
